diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/phy-entity.cc ns-3.39/src/wifi/model/phy-entity.cc
--- ns-3.38/src/wifi/model/phy-entity.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/phy-entity.cc	2023-07-05 14:23:48.117428300 -0700
@@ -246,8 +246,7 @@
                    "version in the amendment-specific subclasses instead!");
     return Create<WifiPpdu>(psdus.begin()->second,
                             txVector,
-                            m_wifiPhy->GetOperatingChannel().GetPrimaryChannelCenterFrequency(
-                                txVector.GetChannelWidth())); // should be overloaded
+                            m_wifiPhy->GetOperatingChannel()); // should be overloaded
 }
 
 Time
@@ -401,16 +400,13 @@
                                 Time rxDuration)
 {
     // The total RX power corresponds to the maximum over all the bands
-    auto it = std::max_element(
-        rxPowersW.begin(),
-        rxPowersW.end(),
-        [](const std::pair<WifiSpectrumBand, double>& p1,
-           const std::pair<WifiSpectrumBand, double>& p2) { return p1.second < p2.second; });
+    auto it =
+        std::max_element(rxPowersW.begin(), rxPowersW.end(), [](const auto& p1, const auto& p2) {
+            return p1.second < p2.second;
+        });
     NS_LOG_FUNCTION(this << ppdu << it->second);
 
-    Ptr<Event> event = m_wifiPhy->GetPhyEntityForPpdu(ppdu)->DoGetEvent(
-        ppdu,
-        rxPowersW); // use latest PHY entity to handle MU-RTS sent with non-HT rate
+    auto event = DoGetEvent(ppdu, rxPowersW);
     if (!event)
     {
         // PPDU should be simply considered as interference (once it has been accounted for in
@@ -826,7 +822,7 @@
     }
 }
 
-std::pair<uint16_t, WifiSpectrumBand>
+std::pair<uint16_t, WifiSpectrumBandInfo>
 PhyEntity::GetChannelWidthAndBand(const WifiTxVector& txVector, uint16_t /* staId */) const
 {
     uint16_t channelWidth = GetRxChannelWidth(txVector);
@@ -851,26 +847,53 @@
 Ptr<Event>
 PhyEntity::DoGetEvent(Ptr<const WifiPpdu> ppdu, RxPowerWattPerChannelBand& rxPowersW)
 {
-    Ptr<Event> event =
-        CreateInterferenceEvent(ppdu, ppdu->GetTxVector(), ppdu->GetTxDuration(), rxPowersW);
-
+    Ptr<Event> event;
     // We store all incoming preamble events, and a decision is made at the end of the preamble
     // detection window.
-    auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
-    NS_ASSERT(m_wifiPhy->m_currentPreambleEvents.find(uidPreamblePair) ==
-              m_wifiPhy->m_currentPreambleEvents.end());
-    m_wifiPhy->m_currentPreambleEvents.insert({uidPreamblePair, event});
+    const auto uidPreamblePair = std::make_pair(ppdu->GetUid(), ppdu->GetPreamble());
+    const auto& currentPreambleEvents = GetCurrentPreambleEvents();
+    const auto it = currentPreambleEvents.find(uidPreamblePair);
+    if (it != currentPreambleEvents.cend())
+    {
+        // received another signal with the same content
+        NS_LOG_DEBUG("Received another PPDU for UID " << ppdu->GetUid());
+        event = it->second;
+        const auto maxDelay =
+            m_wifiPhy->GetPhyEntityForPpdu(ppdu)->GetMaxDelayPpduSameUid(ppdu->GetTxVector());
+        if (Simulator::Now() - event->GetStartTime() > maxDelay)
+        {
+            // This PPDU arrived too late to be decoded properly. The PPDU is dropped and added as
+            // interference
+            event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPowersW);
+            NS_LOG_DEBUG("Drop PPDU that arrived too late");
+            m_wifiPhy->NotifyRxDrop(GetAddressedPsduInPpdu(ppdu), PPDU_TOO_LATE);
+        }
+        else
+        {
+            // Update received power of the event associated to that transmission
+            UpdateInterferenceEvent(event, rxPowersW);
+        }
+        return nullptr;
+    }
+    else
+    {
+        event = CreateInterferenceEvent(ppdu, ppdu->GetTxDuration(), rxPowersW);
+        AddPreambleEvent(event);
+    }
     return event;
 }
 
 Ptr<Event>
 PhyEntity::CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
-                                   const WifiTxVector& txVector,
                                    Time duration,
                                    RxPowerWattPerChannelBand& rxPower,
                                    bool isStartOfdmaRxing /* = false */)
 {
-    return m_wifiPhy->m_interference->Add(ppdu, txVector, duration, rxPower, isStartOfdmaRxing);
+    return m_wifiPhy->m_interference->Add(ppdu,
+                                          ppdu->GetTxVector(),
+                                          duration,
+                                          rxPower,
+                                          isStartOfdmaRxing);
 }
 
 void
@@ -882,7 +905,7 @@
 void
 PhyEntity::NotifyInterferenceRxEndAndClear(bool reset)
 {
-    m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now());
+    m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now(), m_wifiPhy->GetCurrentFrequencyRange());
     m_signalNoiseMap.clear();
     m_statusPerMpduMap.clear();
     for (const auto& endOfMpduEvent : m_endOfMpduEvents)
@@ -958,7 +981,8 @@
         m_wifiPhy->m_currentPreambleEvents.erase(it);
         // This is needed to cleanup the m_firstPowerPerBand so that the first power corresponds to
         // the power at the start of the PPDU
-        m_wifiPhy->m_interference->NotifyRxEnd(maxEvent->GetStartTime());
+        m_wifiPhy->m_interference->NotifyRxEnd(maxEvent->GetStartTime(),
+                                               m_wifiPhy->GetCurrentFrequencyRange());
         // Make sure InterferenceHelper keeps recording events
         m_wifiPhy->m_interference->NotifyRxStart();
         return;
@@ -1000,7 +1024,8 @@
                     // This is needed to cleanup the m_firstPowerPerBand so that the first power
                     // corresponds to the power at the start of the PPDU
                     m_wifiPhy->m_interference->NotifyRxEnd(
-                        m_wifiPhy->m_currentEvent->GetStartTime());
+                        m_wifiPhy->m_currentEvent->GetStartTime(),
+                        m_wifiPhy->GetCurrentFrequencyRange());
                 }
                 else
                 {
@@ -1044,7 +1069,8 @@
         if (m_wifiPhy->m_currentPreambleEvents.empty())
         {
             // Do not erase events if there are still pending preamble events to be processed
-            m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now());
+            m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now(),
+                                                   m_wifiPhy->GetCurrentFrequencyRange());
         }
         m_wifiPhy->m_currentEvent = nullptr;
         // Cancel preamble reception
@@ -1137,7 +1163,7 @@
     NS_LOG_FUNCTION(this << *event);
     DoResetReceive(event);
     NS_ASSERT(!m_wifiPhy->IsStateRx());
-    m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now());
+    m_wifiPhy->m_interference->NotifyRxEnd(Simulator::Now(), m_wifiPhy->GetCurrentFrequencyRange());
     NS_ASSERT(m_endRxPayloadEvents.size() == 1 && m_endRxPayloadEvents.front().IsExpired());
     m_endRxPayloadEvents.clear();
     m_wifiPhy->m_currentEvent = nullptr;
@@ -1170,7 +1196,7 @@
     return m_wifiPhy->m_currentEvent;
 }
 
-WifiSpectrumBand
+WifiSpectrumBandInfo
 PhyEntity::GetPrimaryBand(uint16_t bandWidth) const
 {
     if (m_wifiPhy->GetChannelWidth() % 20 != 0)
@@ -1181,7 +1207,7 @@
                               m_wifiPhy->m_operatingChannel.GetPrimaryChannelIndex(bandWidth));
 }
 
-WifiSpectrumBand
+WifiSpectrumBandInfo
 PhyEntity::GetSecondaryBand(uint16_t bandWidth) const
 {
     NS_ASSERT(m_wifiPhy->GetChannelWidth() >= 40);
@@ -1203,7 +1229,7 @@
 }
 
 Time
-PhyEntity::GetDelayUntilCcaEnd(double thresholdDbm, WifiSpectrumBand band)
+PhyEntity::GetDelayUntilCcaEnd(double thresholdDbm, const WifiSpectrumBandInfo& band)
 {
     return m_wifiPhy->m_interference->GetEnergyDuration(DbmToW(thresholdDbm), band);
 }
@@ -1263,6 +1289,12 @@
     return m_globalPpduUid++;
 }
 
+Time
+PhyEntity::GetMaxDelayPpduSameUid(const WifiTxVector& /*txVector*/)
+{
+    return Seconds(0);
+}
+
 uint16_t
 PhyEntity::GetCenterFrequencyForChannelWidth(const WifiTxVector& txVector) const
 {
@@ -1353,11 +1385,7 @@
     const auto txCenterFreq = ppdu->GetTxCenterFreq();
     const auto minTxFreq = txCenterFreq - txChannelWidth / 2;
     const auto maxTxFreq = txCenterFreq + txChannelWidth / 2;
-    if (p20MinFreq < minTxFreq || p20MaxFreq > maxTxFreq)
-    {
-        return false;
-    }
-    return true;
+    return p20MinFreq >= minTxFreq && p20MaxFreq <= maxTxFreq;
 }
 
 Ptr<const WifiPpdu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/phy-entity.h ns-3.39/src/wifi/model/phy-entity.h
--- ns-3.38/src/wifi/model/phy-entity.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/phy-entity.h	2023-07-05 14:23:48.117428300 -0700
@@ -75,7 +75,7 @@
 /**
  * A map of the received power (Watts) for each band
  */
-typedef std::map<WifiSpectrumBand, double> RxPowerWattPerChannelBand;
+using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, double>;
 
 class WifiPsdu;
 class WifiPhy;
@@ -548,6 +548,15 @@
      */
     virtual uint64_t ObtainNextUid(const WifiTxVector& txVector);
 
+    /**
+     * Obtain the maximum time between two PPDUs with the same UID to consider they are identical
+     * and their power can be added construtively.
+     *
+     * \param txVector the TXVECTOR used for the transmission of the PPDUs
+     * \return the maximum time between two PPDUs with the same UID to decode them
+     */
+    virtual Time GetMaxDelayPpduSameUid(const WifiTxVector& txVector);
+
   protected:
     /**
      * A map of PPDU field elements per preamble type.
@@ -766,7 +775,7 @@
      * \param staId the station ID of the PSDU
      * \return a pair of channel width (MHz) and band
      */
-    virtual std::pair<uint16_t, WifiSpectrumBand> GetChannelWidthAndBand(
+    virtual std::pair<uint16_t, WifiSpectrumBandInfo> GetChannelWidthAndBand(
         const WifiTxVector& txVector,
         uint16_t staId) const;
 
@@ -827,10 +836,14 @@
      * Create an event using WifiPhy's InterferenceHelper class.
      * Wrapper used by child classes.
      *
-     * \copydoc InterferenceHelper::Add
+     * \param ppdu the PPDU
+     * \param duration the PPDU duration
+     * \param rxPower received power per band (W)
+     * \param isStartOfdmaRxing flag whether the event corresponds to the start of the OFDMA payload
+     * reception (only used for UL-OFDMA)
+     * \return the created event
      */
     Ptr<Event> CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
-                                       const WifiTxVector& txVector,
                                        Time duration,
                                        RxPowerWattPerChannelBand& rxPower,
                                        bool isStartOfdmaRxing = false);
@@ -838,7 +851,8 @@
      * Update an event in WifiPhy's InterferenceHelper class.
      * Wrapper used by child classes.
      *
-     * \copydoc InterferenceHelper::UpdateEvent
+     * \param event the event to be updated
+     * \param rxPower the received power (W) per band to be added to the current event
      */
     void UpdateInterferenceEvent(Ptr<Event> event, const RxPowerWattPerChannelBand& rxPower);
     /**
@@ -879,27 +893,27 @@
     void NotifyPayloadBegin(const WifiTxVector& txVector, const Time& payloadDuration);
 
     /**
-     * If the operating channel width is a multiple of 20 MHz, return the start
-     * band index and the stop band index for the primary channel of the given
+     * If the operating channel width is a multiple of 20 MHz, return the info
+     * corresponding to the primary channel of the given
      * bandwidth (which must be a multiple of 20 MHz and not exceed the operating
      * channel width). Otherwise, this call is equivalent to GetBand with
      * <i>bandIndex</i> equal to zero.
      *
      * \param bandWidth the width of the band to be returned (MHz)
      *
-     * \return a pair of start and stop indexes that defines the band
+     * \return the info corresponding to the band
      */
-    WifiSpectrumBand GetPrimaryBand(uint16_t bandWidth) const;
+    WifiSpectrumBandInfo GetPrimaryBand(uint16_t bandWidth) const;
     /**
-     * If the channel bonding is used, return the start band index and the stop band index
-     * for the secondary channel of the given bandwidth (which must be a multiple of 20 MHz
+     * If the channel bonding is used, return the info corresponding to
+     * the secondary channel of the given bandwidth (which must be a multiple of 20 MHz
      * and not exceed the operating channel width).
      *
      * \param bandWidth the width of the band to be returned (MHz)
      *
-     * \return a pair of start and stop indexes that defines the band
+     * \return the info corresponding to the band
      */
-    WifiSpectrumBand GetSecondaryBand(uint16_t bandWidth) const;
+    WifiSpectrumBandInfo GetSecondaryBand(uint16_t bandWidth) const;
 
     /**
      * Return the channel width used to measure the RSSI.
@@ -925,7 +939,7 @@
      * \param band identify the requested band
      * \return the delay until CCA busy is ended
      */
-    Time GetDelayUntilCcaEnd(double thresholdDbm, WifiSpectrumBand band);
+    Time GetDelayUntilCcaEnd(double thresholdDbm, const WifiSpectrumBandInfo& band);
 
     /**
      * \param currentChannelWidth channel width of the current transmission (MHz)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/qos-frame-exchange-manager.cc ns-3.39/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.38/src/wifi/model/qos-frame-exchange-manager.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/qos-frame-exchange-manager.cc	2023-07-05 14:23:48.117428300 -0700
@@ -108,11 +108,14 @@
     {
         NS_LOG_DEBUG("Send CF-End frame");
         m_phy->Send(Create<WifiPsdu>(Create<Packet>(), cfEnd), cfEndTxVector);
-        Simulator::Schedule(txDuration, &Txop::NotifyChannelReleased, m_edca, m_linkId);
+        Simulator::Schedule(txDuration,
+                            &QosFrameExchangeManager::NotifyChannelReleased,
+                            this,
+                            m_edca);
         return true;
     }
 
-    m_edca->NotifyChannelReleased(m_linkId);
+    NotifyChannelReleased(m_edca);
     m_edca = nullptr;
     return false;
 }
@@ -128,7 +131,7 @@
     if (m_channelAccessManager->GetAccessGrantStart() - m_phy->GetSifs() >
         Simulator::Now() - m_phy->GetPifs())
     {
-        m_edca->NotifyChannelReleased(m_linkId);
+        NotifyChannelReleased(m_edca);
         m_edca = nullptr;
     }
     else
@@ -147,7 +150,7 @@
 
     NS_LOG_DEBUG("Cancel PIFS recovery being attempted by EDCAF " << m_edca);
     m_pifsRecoveryEvent.Cancel();
-    m_edca->NotifyChannelReleased(m_linkId);
+    NotifyChannelReleased(m_edca);
 }
 
 bool
@@ -230,7 +233,7 @@
 
             // TXOP not even started, return false
             NS_LOG_DEBUG("No frame transmitted");
-            m_edca->NotifyChannelReleased(m_linkId);
+            NotifyChannelReleased(m_edca);
             m_edca = nullptr;
             return false;
         }
@@ -257,7 +260,7 @@
     }
 
     NS_LOG_DEBUG("No frame transmitted");
-    m_edca->NotifyChannelReleased(m_linkId);
+    NotifyChannelReleased(m_edca);
     m_edca = nullptr;
     return false;
 }
@@ -582,7 +585,7 @@
     }
     else
     {
-        m_edca->NotifyChannelReleased(m_linkId);
+        NotifyChannelReleased(m_edca);
         m_edca = nullptr;
     }
     m_initialFrame = false;
@@ -605,7 +608,7 @@
         // The backoff procedure shall be invoked by an EDCAF when the transmission
         // of an MPDU in the initial PPDU of a TXOP fails (Sec. 10.22.2.2 of 802.11-2016)
         NS_LOG_DEBUG("TX of the initial frame of a TXOP failed: terminate TXOP");
-        m_edca->NotifyChannelReleased(m_linkId);
+        NotifyChannelReleased(m_edca);
         m_edca = nullptr;
     }
     else
@@ -713,6 +716,20 @@
 }
 
 void
+QosFrameExchangeManager::UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector)
+{
+    NS_LOG_FUNCTION(this << psdu << txVector);
+    if (psdu->GetHeader(0).IsCfEnd())
+    {
+        NS_LOG_DEBUG("Received CF-End, resetting NAV");
+        NavResetTimeout();
+        return;
+    }
+
+    FrameExchangeManager::UpdateNav(psdu, txVector);
+}
+
+void
 QosFrameExchangeManager::NavResetTimeout()
 {
     NS_LOG_FUNCTION(this);
@@ -732,13 +749,6 @@
     double rxSnr = rxSignalInfo.snr;
     const WifiMacHeader& hdr = mpdu->GetHeader();
 
-    if (hdr.IsCfEnd())
-    {
-        // reset NAV
-        NavResetTimeout();
-        return;
-    }
-
     if (hdr.IsRts())
     {
         NS_ABORT_MSG_IF(inAmpdu, "Received RTS as part of an A-MPDU");
@@ -779,11 +789,8 @@
                                 rxSnr);
         }
 
-        // Forward up the frame if it is not a QoS Null frame
-        if (hdr.HasData())
-        {
-            m_rxMiddle->Receive(mpdu, m_linkId);
-        }
+        // Forward up the frame
+        m_rxMiddle->Receive(mpdu, m_linkId);
 
         // the received data frame has been processed
         return;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/qos-frame-exchange-manager.h ns-3.39/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.38/src/wifi/model/qos-frame-exchange-manager.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/qos-frame-exchange-manager.h	2023-07-05 14:23:48.117428300 -0700
@@ -114,6 +114,7 @@
     void PreProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void PostProcessFrame(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     void NavResetTimeout() override;
+    void UpdateNav(Ptr<const WifiPsdu> psdu, const WifiTxVector& txVector) override;
     Time GetFrameDurationId(const WifiMacHeader& header,
                             uint32_t size,
                             const WifiTxParameters& txParams,
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/qos-txop.cc ns-3.39/src/wifi/model/qos-txop.cc
--- ns-3.38/src/wifi/model/qos-txop.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/qos-txop.cc	2023-07-05 14:23:48.117428300 -0700
@@ -28,7 +28,7 @@
 #include "mgt-headers.h"
 #include "mpdu-aggregator.h"
 #include "msdu-aggregator.h"
-#include "qos-blocked-destinations.h"
+#include "wifi-mac-queue-scheduler.h"
 #include "wifi-mac-queue.h"
 #include "wifi-mac-trailer.h"
 #include "wifi-phy.h"
@@ -108,13 +108,26 @@
       m_ac(ac)
 {
     NS_LOG_FUNCTION(this);
-    m_qosBlockedDestinations = Create<QosBlockedDestinations>();
     m_baManager = CreateObject<BlockAckManager>();
     m_baManager->SetQueue(m_queue);
     m_baManager->SetBlockDestinationCallback(
-        MakeCallback(&QosBlockedDestinations::Block, m_qosBlockedDestinations));
+        Callback<void, Mac48Address, uint8_t>([this](Mac48Address recipient, uint8_t tid) {
+            m_mac->GetMacQueueScheduler()->BlockQueues(WifiQueueBlockedReason::WAITING_ADDBA_RESP,
+                                                       m_ac,
+                                                       {WIFI_QOSDATA_QUEUE},
+                                                       recipient,
+                                                       m_mac->GetLocalAddress(recipient),
+                                                       {tid});
+        }));
     m_baManager->SetUnblockDestinationCallback(
-        MakeCallback(&QosBlockedDestinations::Unblock, m_qosBlockedDestinations));
+        Callback<void, Mac48Address, uint8_t>([this](Mac48Address recipient, uint8_t tid) {
+            m_mac->GetMacQueueScheduler()->UnblockQueues(WifiQueueBlockedReason::WAITING_ADDBA_RESP,
+                                                         m_ac,
+                                                         {WIFI_QOSDATA_QUEUE},
+                                                         recipient,
+                                                         m_mac->GetLocalAddress(recipient),
+                                                         {tid});
+        }));
     m_queue->TraceConnectWithoutContext(
         "Expired",
         MakeCallback(&BlockAckManager::NotifyDiscardedMpdu, m_baManager));
@@ -134,7 +147,6 @@
         m_baManager->Dispose();
     }
     m_baManager = nullptr;
-    m_qosBlockedDestinations = nullptr;
     Txop::DoDispose();
 }
 
@@ -153,7 +165,7 @@
 uint8_t
 QosTxop::GetQosQueueSize(uint8_t tid, Mac48Address receiver) const
 {
-    WifiContainerQueueId queueId{WIFI_QOSDATA_UNICAST_QUEUE, receiver, tid};
+    WifiContainerQueueId queueId{WIFI_QOSDATA_QUEUE, WIFI_UNICAST, receiver, tid};
     uint32_t bufferSize = m_queue->GetNBytes(queueId);
     // A queue size value of 254 is used for all sizes greater than 64 768 octets.
     uint8_t queueSize = static_cast<uint8_t>(std::ceil(std::min(bufferSize, 64769U) / 256.0));
@@ -275,7 +287,7 @@
     return m_baManager->GetOriginatorStartingSequence(address, tid);
 }
 
-Ptr<WifiMpdu>
+std::pair<CtrlBAckRequestHeader, WifiMacHeader>
 QosTxop::PrepareBlockAckRequest(Mac48Address recipient, uint8_t tid) const
 {
     NS_LOG_FUNCTION(this << recipient << +tid);
@@ -285,8 +297,6 @@
 
     CtrlBAckRequestHeader reqHdr =
         m_baManager->GetBlockAckReqHeader(recipientMld.value_or(recipient), tid);
-    Ptr<Packet> bar = Create<Packet>();
-    bar->AddHeader(reqHdr);
 
     WifiMacHeader hdr;
     hdr.SetType(WIFI_MAC_CTL_BACKREQ);
@@ -297,7 +307,7 @@
     hdr.SetNoRetry();
     hdr.SetNoMoreFragments();
 
-    return Create<WifiMpdu>(bar, hdr);
+    return {reqHdr, hdr};
 }
 
 bool
@@ -311,7 +321,7 @@
 {
     // remove MSDUs with expired lifetime starting from the head of the queue
     m_queue->WipeAllExpiredMpdus();
-    bool queueIsNotEmpty = (bool)(m_queue->PeekFirstAvailable(linkId, m_qosBlockedDestinations));
+    bool queueIsNotEmpty = (bool)(m_queue->PeekFirstAvailable(linkId));
 
     NS_LOG_FUNCTION(this << queueIsNotEmpty);
     return queueIsNotEmpty;
@@ -347,12 +357,8 @@
         return false;
     }
 
-    if (QosUtilsIsOldPacket(GetBaStartingSequence(recipient, tid),
-                            mpdu->GetHeader().GetSequenceNumber()))
-    {
-        return true;
-    }
-    return false;
+    return QosUtilsIsOldPacket(GetBaStartingSequence(recipient, tid),
+                               mpdu->GetHeader().GetSequenceNumber());
 }
 
 Ptr<WifiMpdu>
@@ -364,13 +370,15 @@
     auto peek = [this, &linkId, &tid, &recipient, &mpdu]() -> Ptr<WifiMpdu> {
         if (tid == 8 && recipient.IsBroadcast()) // undefined TID and recipient
         {
-            return m_queue->PeekFirstAvailable(linkId, m_qosBlockedDestinations, mpdu);
+            return m_queue->PeekFirstAvailable(linkId, mpdu);
         }
-        if (m_qosBlockedDestinations->IsBlocked(recipient, tid))
+        WifiContainerQueueId queueId(WIFI_QOSDATA_QUEUE, WIFI_UNICAST, recipient, tid);
+        if (auto mask = m_mac->GetMacQueueScheduler()->GetQueueLinkMask(m_ac, queueId, linkId);
+            !mask || mask->none())
         {
-            return nullptr;
+            return m_queue->PeekByQueueId(queueId, mpdu);
         }
-        return m_queue->PeekByTidAndAddress(tid, recipient, mpdu);
+        return nullptr;
     };
 
     auto item = peek();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/qos-txop.h ns-3.39/src/wifi/model/qos-txop.h
--- ns-3.38/src/wifi/model/qos-txop.h	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/qos-txop.h	2023-07-05 14:23:48.117428300 -0700
@@ -31,7 +31,6 @@
 namespace ns3
 {
 
-class QosBlockedDestinations;
 class MgtAddBaResponseHeader;
 class MgtDelBaHeader;
 class AggregationCapableTransmissionListener;
@@ -137,14 +136,15 @@
     /**
      * \param recipient Address of recipient.
      * \param tid traffic ID.
-     * \return the BlockAckRequest to send
+     * \return the BlockAckRequest header and the MAC header for the BlockAckReq
      *
      * Prepare a BlockAckRequest to be sent to <i>recipient</i> for Traffic ID
      * <i>tid</i>. The header for the BlockAckRequest is requested to the QosTxop
      * corresponding to the given TID. A block ack agreement with the given recipient
      * for the given TID must have been established by such QosTxop.
      */
-    Ptr<WifiMpdu> PrepareBlockAckRequest(Mac48Address recipient, uint8_t tid) const;
+    std::pair<CtrlBAckRequestHeader, WifiMacHeader> PrepareBlockAckRequest(Mac48Address recipient,
+                                                                           uint8_t tid) const;
 
     /* Event handlers */
     /**
@@ -464,9 +464,8 @@
      */
     bool IsQosOldPacket(Ptr<const WifiMpdu> mpdu);
 
-    AcIndex m_ac;                                         //!< the access category
-    Ptr<QosBlockedDestinations> m_qosBlockedDestinations; //!< the QoS blocked destinations
-    Ptr<BlockAckManager> m_baManager;                     //!< the block ack manager
+    AcIndex m_ac;                     //!< the access category
+    Ptr<BlockAckManager> m_baManager; //!< the block ack manager
     uint8_t m_blockAckThreshold; /**< the block ack threshold (use BA mechanism if number of packets
                                     in queue reaches this value. If this value is 0, block ack is
                                     never used. When A-MPDU is enabled, block ack mechanism is used
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/qos-utils.cc ns-3.39/src/wifi/model/qos-utils.cc
--- ns-3.38/src/wifi/model/qos-utils.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/qos-utils.cc	2023-07-05 14:23:48.117428300 -0700
@@ -139,19 +139,15 @@
     case 0:
     case 3:
         return AC_BE;
-        break;
     case 1:
     case 2:
         return AC_BK;
-        break;
     case 4:
     case 5:
         return AC_VI;
-        break;
     case 6:
     case 7:
         return AC_VO;
-        break;
     }
     return AC_UNDEF;
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/rate-control/aarfcd-wifi-manager.cc ns-3.39/src/wifi/model/rate-control/aarfcd-wifi-manager.cc
--- ns-3.38/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/rate-control/aarfcd-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
@@ -366,7 +366,7 @@
         channelWidth = 20;
     }
     WifiMode mode;
-    if (GetUseNonErpProtection() == false)
+    if (!GetUseNonErpProtection())
     {
         mode = GetSupported(station, 0);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/rate-control/aarf-wifi-manager.cc ns-3.39/src/wifi/model/rate-control/aarf-wifi-manager.cc
--- ns-3.38/src/wifi/model/rate-control/aarf-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/rate-control/aarf-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
@@ -297,7 +297,7 @@
         channelWidth = 20;
     }
     WifiMode mode;
-    if (GetUseNonErpProtection() == false)
+    if (!GetUseNonErpProtection())
     {
         mode = GetSupported(station, 0);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/rate-control/amrr-wifi-manager.cc ns-3.39/src/wifi/model/rate-control/amrr-wifi-manager.cc
--- ns-3.38/src/wifi/model/rate-control/amrr-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/rate-control/amrr-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
@@ -411,7 +411,7 @@
     }
     UpdateMode(station);
     WifiMode mode;
-    if (GetUseNonErpProtection() == false)
+    if (!GetUseNonErpProtection())
     {
         mode = GetSupported(station, 0);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/wifi/model/rate-control/aparf-wifi-manager.cc ns-3.39/src/wifi/model/rate-control/aparf-wifi-manager.cc
--- ns-3.38/src/wifi/model/rate-control/aparf-wifi-manager.cc	2023-03-16 20:54:23.860869400 -0700
+++ ns-3.39/src/wifi/model/rate-control/aparf-wifi-manager.cc	2023-07-05 14:23:48.117428300 -0700
@@ -70,13 +70,13 @@
                           "The minimum number of successful transmissions in \"High\" state to try "
                           "a new power or rate.",
                           UintegerValue(3),
-                          MakeUintegerAccessor(&AparfWifiManager::m_succesMax1),
+                          MakeUintegerAccessor(&AparfWifiManager::m_successMax1),
                           MakeUintegerChecker<uint32_t>())
             .AddAttribute("SuccessThreshold2",
                           "The minimum number of successful transmissions in \"Low\" state to try "
                           "a new power or rate.",
                           UintegerValue(10),
-                          MakeUintegerAccessor(&AparfWifiManager::m_succesMax2),
+                          MakeUintegerAccessor(&AparfWifiManager::m_successMax2),
                           MakeUintegerChecker<uint32_t>())
             .AddAttribute("FailThreshold",
                           "The minimum number of failed transmissions to try a new power or rate.",
@@ -162,7 +162,7 @@
     NS_LOG_FUNCTION(this);
     AparfWifiRemoteStation* station = new AparfWifiRemoteStation();
 
-    station->m_successThreshold = m_succesMax1;
+    station->m_successThreshold = m_successMax1;
     station->m_failThreshold = m_failMax;
     station->m_nSuccess = 0;
     station->m_nFailed = 0;
@@ -217,12 +217,12 @@
     if (station->m_aparfState == AparfWifiManager::Low)
     {
         station->m_aparfState = AparfWifiManager::High;
-        station->m_successThreshold = m_succesMax1;
+        station->m_successThreshold = m_successMax1;
     }
     else if (station->m_aparfState == AparfWifiManager::Spread)
     {
         station->m_aparfState = AparfWifiManager::Low;
-        station->m_successThreshold = m_succesMax2;
+        station->m_successThreshold = m_successMax2;
     }
 
     if (station->m_nFailed == station->m_failThreshold)
@@ -291,7 +291,7 @@
     else if (station->m_aparfState == AparfWifiManager::Spread)
     {
         station->m_aparfState = AparfWifiManager::High;
-        station->m_successThreshold = m_succesMax1;
+        station->m_successThreshold = m_successMax1;
     }
 
     if (station->m_nSuccess == station->m_successThreshold)
@@ -402,7 +402,7 @@
         channelWidth = 20;
     }
     WifiMode mode;
-    if (GetUseNonErpProtection() == false)
+    if (!GetUseNonErpProtection())
     {
         mode = GetSupported(station, 0);
     }
